// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_CALENDAR_H
#define _GTKMM_CALENDAR_H

#include <glibmm.h>

/* $Id: calendar.hg,v 1.17 2002/07/08 15:17:30 murrayc Exp $ */

/* calendar.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/widget.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkCalendar GtkCalendar;
typedef struct _GtkCalendarClass GtkCalendarClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Calendar_Class; } // namespace Gtk
namespace Gtk
{


/** @addtogroup gtkmmEnums Enums and Flags */

/**
 * @ingroup gtkmmEnums
 * @par Bitwise operators:
 * <tt>%CalendarDisplayOptions operator|(CalendarDisplayOptions, CalendarDisplayOptions)</tt><br>
 * <tt>%CalendarDisplayOptions operator&(CalendarDisplayOptions, CalendarDisplayOptions)</tt><br>
 * <tt>%CalendarDisplayOptions operator~(CalendarDisplayOptions)</tt><br>
 */
enum CalendarDisplayOptions
{
  CALENDAR_SHOW_HEADING = 1 << 0,
  CALENDAR_SHOW_DAY_NAMES = 1 << 1,
  CALENDAR_NO_MONTH_CHANGE = 1 << 2,
  CALENDAR_SHOW_WEEK_NUMBERS = 1 << 3,
  CALENDAR_WEEK_START_MONDAY = 1 << 4
};

/** @ingroup gtkmmEnums */
inline CalendarDisplayOptions operator|(CalendarDisplayOptions lhs, CalendarDisplayOptions rhs)
  { return static_cast<CalendarDisplayOptions>(static_cast<unsigned>(lhs) | static_cast<unsigned>(rhs)); }

/** @ingroup gtkmmEnums */
inline CalendarDisplayOptions operator&(CalendarDisplayOptions lhs, CalendarDisplayOptions rhs)
  { return static_cast<CalendarDisplayOptions>(static_cast<unsigned>(lhs) & static_cast<unsigned>(rhs)); }

/** @ingroup gtkmmEnums */
inline CalendarDisplayOptions operator~(CalendarDisplayOptions flags)
  { return static_cast<CalendarDisplayOptions>(~static_cast<unsigned>(flags)); }

} // namespace Gtk


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::CalendarDisplayOptions> : public Glib::Value_Flags<Gtk::CalendarDisplayOptions>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


/** Display a calendar and/or allow the user to select a date.
 *
 * This is a widget that displays a calendar,
 * one month at a time.
 *
 * The month and year currently displayed can be altered with {select_month()}.
 * The exact day can be selected from the displayed month using {select_day()}.
 *
 * The way in which the calendar itself is displayed can be altered
 * using {display_options()}.
 *
 * The selected date can be retrieved from a GtkCalendar using
 * {get_date()}.
 *
 * If performing many 'mark' operations, the calendar can be frozen
 * to prevent flicker, using {freeze()}, and 'thawed' again using {thaw()}
 *
 * @ingroup Widgets
 */

class Calendar : public Widget
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Calendar CppObjectType;
  typedef Calendar_Class CppClassType;
  typedef GtkCalendar BaseObjectType;
  typedef GtkCalendarClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Calendar();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Calendar_Class;
  static CppClassType calendar_class_;

  // noncopyable
  Calendar(const Calendar&);
  Calendar& operator=(const Calendar&);

protected:
  explicit Calendar(const Glib::ConstructParams& construct_params);
  explicit Calendar(GtkCalendar* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  GtkCalendar*       gobj()       { return reinterpret_cast<GtkCalendar*>(gobject_); }
  const GtkCalendar* gobj() const { return reinterpret_cast<GtkCalendar*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_month_changed();
  virtual void on_day_selected();
  virtual void on_day_selected_double_click();
  virtual void on_prev_month();
  virtual void on_next_month();
  virtual void on_prev_year();
  virtual void on_next_year();


private:

public:

  Calendar();
  

  /** 
   * Shifts the calendar to a different month.
   * 
   * @param month A month number between 0 and 11.
   * @param year The year the month is in.
   * @return <tt>true</tt>.
   */
  int select_month(guint month, guint year);
  
  /** 
   * Selects a day from the current month.
   * 
   * 
   *    the currently selected day.
   * @param day The day number between 1 and 31, or 0 to unselect.
   */
  void select_day(guint day);
  
  /** 
   * Places a visual marker on a particular day.
   * 
   * @param day The day number to mark between 1 and 31.
   * @return <tt>true</tt>.
   */
  int mark_day(guint day);
  
  /** 
   * Removes the visual marker from a particular day.
   * 
   * @param day The day number to unmark between 1 and 31.
   * @return <tt>true</tt>.
   */
  int unmark_day(guint day);
  
  /** 
   * Remove all visual markers.
   * 
   */
  void clear_marks();
  
  /** 
   * Sets display options (whether to display the heading and the month headings).
   * 
   * @param flags The display options to set.
   */
  void display_options(CalendarDisplayOptions flags);
  
  /** 
   * Obtains the selected date from a Gtk::Calendar.
   * 
   * @param year Location to store the year number.
   * @param month Location to store the month number.
   * @param day Location to store the day number.
   */
  void get_date(guint& year, guint& month, guint& day) const;
  
  /** 
   * Locks the display of the calendar until it is thawed with thaw().
   * 
   */
  void freeze();
  
  /** 
   * Defrosts a calendar; all the changes made since the last
   * freeze() are displayed.
   * 
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkCalendar::day-selected ##### --&gt;
   * 
   * Emitted when the user selects a day.
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkCalendar::day-selected-double-click ##### --&gt;
   * 
   * 
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkCalendar::month-changed ##### --&gt;
   * 
   * Emitted when the user clicks a button to change the selected month on a
   * calendar.
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkCalendar::next-month ##### --&gt;
   * 
   * 
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkCalendar::next-year ##### --&gt;
   * 
   * 
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkCalendar::prev-month ##### --&gt;
   * 
   * 
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkCalendar::prev-year ##### --&gt;
   * 
   * 
   * 
   */
  void thaw();

  
  /**
   * @par Prototype:
   * <tt>void %month_changed()</tt>
   */
  Glib::SignalProxy0<void> signal_month_changed();

  
  /**
   * @par Prototype:
   * <tt>void %day_selected()</tt>
   */
  Glib::SignalProxy0<void> signal_day_selected();

  
  /**
   * @par Prototype:
   * <tt>void %day_selected_double_click()</tt>
   */
  Glib::SignalProxy0<void> signal_day_selected_double_click();

  
  /**
   * @par Prototype:
   * <tt>void %prev_month()</tt>
   */
  Glib::SignalProxy0<void> signal_prev_month();

  
  /**
   * @par Prototype:
   * <tt>void %next_month()</tt>
   */
  Glib::SignalProxy0<void> signal_next_month();

  
  /**
   * @par Prototype:
   * <tt>void %prev_year()</tt>
   */
  Glib::SignalProxy0<void> signal_prev_year();

  
  /**
   * @par Prototype:
   * <tt>void %next_year()</tt>
   */
  Glib::SignalProxy0<void> signal_next_year();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Calendar */
  Gtk::Calendar* wrap(GtkCalendar* object, bool take_copy = false);
}
#endif /* _GTKMM_CALENDAR_H */

