// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_MENUSHELL_H
#define _GTKMM_MENUSHELL_H

#include <glibmm.h>

/* $Id: menushell.hg,v 1.40 2002/07/13 15:58:37 murrayc Exp $ */

/* Copyright (C) 1998-1999 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gdk/gdkkeysyms.h>


//__PINCLUDE(gtkmm/label.h)

//__PINCLUDE(gtkmm/accelgroup.h)

#include <gtkmm/container.h>
#include <gtkmm/menu_elems.h>
#include <glibmm/helperlist.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkMenuShell GtkMenuShell;
typedef struct _GtkMenuShellClass GtkMenuShellClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class MenuShell_Class; } // namespace Gtk
namespace Gtk
{

class Menu;
class MenuShell;
class Window;

// FIXME: element should not be virtual!
// TODO: Please give more detail about that comment. murrayc.

namespace Menu_Helpers
{

/*********************************************************************
***** List properties
*********************************************************************/

 
class MenuList : public Glib::HelperList< MenuItem, const Element, Glib::List_Cpp_Iterator<GtkMenuItem,MenuItem> >
{
public:
  MenuList();
  explicit MenuList(GtkMenuShell* gparent);
  MenuList(const MenuList& src);
  virtual ~MenuList() {}

  MenuList& operator=(const MenuList& src);

  typedef Glib::HelperList< MenuItem, const Element,  Glib::List_Cpp_Iterator<GtkMenuItem,MenuItem> > type_base;

  GtkMenuShell* gparent();
  const GtkMenuShell* gparent() const;

  virtual GList*& glist() const;      // front of list

  virtual void erase(iterator start, iterator stop);
  virtual iterator erase(iterator);  //Implented as custom or by LIST_CONTAINER_REMOVE
  virtual void remove(const_reference); //Implented as custom or by LIST_CONTAINER_REMOVE

  /// This is order n. (use at own risk)
  reference operator[](size_type l) const;

public:
  iterator insert(iterator position, element_type& e); //custom-implemented.

  template <class InputIterator>
  inline void insert(iterator position, InputIterator first, InputIterator last)
  {
    for(;first != last; ++first)
      position = insert(position, *first);
  }

 inline void push_front(element_type& e)
    { insert(begin(), e); }
  inline void push_back(element_type& e)
    { insert(end(), e); }


virtual void remove(Widget& w); //Implented as custom or by LIST_CONTAINER_REMOVE

  };


} // namespace Menu_Helpers


/** The abstract base class for Gtk::Menu and Gtk::MenuBar.
 * It is a container of Gtk::MenuItem objects arranged in a list which can be navigated, selected, and activated by the user to perform application functions.
 * It can have a submenu associated with it, allowing for nested hierarchical menus.
 * You can use append(), prepend() and insert() to add Gtk::MenuItem widgets,
 * but you will probably find it more convenient to use the STL-style items() interface with the Gtk::Menu_Helpers::MenuElem() class.
 * @ingroup Widgets
 * @ingroup Containers
 * @ingroup Menus
 */

class MenuShell : public Container 
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef MenuShell CppObjectType;
  typedef MenuShell_Class CppClassType;
  typedef GtkMenuShell BaseObjectType;
  typedef GtkMenuShellClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~MenuShell();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class MenuShell_Class;
  static CppClassType menushell_class_;

  // noncopyable
  MenuShell(const MenuShell&);
  MenuShell& operator=(const MenuShell&);

protected:
  explicit MenuShell(const Glib::ConstructParams& construct_params);
  explicit MenuShell(GtkMenuShell* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  GtkMenuShell*       gobj()       { return reinterpret_cast<GtkMenuShell*>(gobject_); }
  const GtkMenuShell* gobj() const { return reinterpret_cast<GtkMenuShell*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_deactivate();
  virtual void on_selection_done();
  virtual void on_move_current(MenuDirectionType direction);
  virtual void on_activate_current(bool force_hide);
  virtual void on_cancel();


private:


public:
  

  typedef Menu_Helpers::AccelKey AccelKey;
  typedef Menu_Helpers::MenuList MenuList;
  friend class Menu_Helpers::MenuList;

  
  /** 
   * Adds a new Gtk::MenuItem to the end of the menu shell's item list.
   * 
   * @param child The Gtk::MenuItem to add.
   */
  void append(MenuItem& menu_item);
  
  /** 
   * Adds a new Gtk::MenuItem to the beginning of the menu shell's item list.
   * 
   * @param child The Gtk::MenuItem to add.
   */
  void prepend(MenuItem& menu_item);
  
  /** 
   * Adds a new Gtk::MenuItem to the menu shell's item list at the position
   * indicated by @a position. 
   * 
   * 
   * Positions are numbered from 0 to n-1.
   * @param child The Gtk::MenuItem to add.
   * @param position The position in the item list where @a child is added.
   */
  void insert(MenuItem& menu_item, int position);

  
  /** 
   * Selects the menu item from the menu shell.
   * 
   * @param menu_item The Gtk::MenuItem to select.
   */
  void select_item(MenuItem& menu_item);
  
  /** 
   * Deselects the currently selected item from the menu shell, if any.
   * 
   */
  void deselect();

  //TODO: Is force_deactivate = false a good default?
  
  /** 
   * Activates the menu item within the menu shell.
   * 
   * 
   * after the menu item is activated.
   * @param menu_item The Gtk::MenuItem to activate.
   * @param force_deactivate If TRUE, force the deactivation of the menu shell.
   */
  void activate_item(MenuItem& menu_item, bool force_deactivate = false);
  
  /** 
   * Deactivates the menu shell.  Typically this results in the menu shell
   * being erased from the screen.
   * 
   */
  void deactivate();

  
  /**
   * @par Prototype:
   * <tt>void %deactivate()</tt>
   */
  Glib::SignalProxy0<void> signal_deactivate();

  
  /**
   * @par Prototype:
   * <tt>void %selection_done()</tt>
   */
  Glib::SignalProxy0<void> signal_selection_done();

  
  /**
   * @par Prototype:
   * <tt>void %move_current(MenuDirectionType direction)</tt>
   */
  Glib::SignalProxy1<void,MenuDirectionType> signal_move_current();

  
  /**
   * @par Prototype:
   * <tt>void %activate_current(bool force_hide)</tt>
   */
  Glib::SignalProxy1<void,bool> signal_activate_current();

  
  /**
   * @par Prototype:
   * <tt>void %cancel()</tt>
   */
  Glib::SignalProxy0<void> signal_cancel();

  
  MenuList& items();
  const MenuList& items() const;

  /** assign the menu to a window
   * Use this function to assign a popup menu to act as keyboard
   * accelerators for a window.  A popup menu is one which acts
   * without a parent.
   *
   * This function has no gtk+ equivelent.  In gtk+, you create
   * an accelerator group and then create items with the group
   * then later assign the group to the window.  To automate this
   * and save passing arround the group, assignment of accelerators
   * is held off until you assign the menu to its window.
   *
   * It is not necessary to call this on menubars as they perform this
   * automatically.
   */
  void accelerate(Window& window);

protected:
  MenuShell();
  

private:


  MenuList      items_proxy_;
  Gtk::Window*  accel_window_;


};

} // namespace Gtk


namespace Glib
{
  /** @relates Gtk::MenuShell */
  Gtk::MenuShell* wrap(GtkMenuShell* object, bool take_copy = false);
}
#endif /* _GTKMM_MENUSHELL_H */

