// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_SCROLLEDWINDOW_H
#define _GTKMM_SCROLLEDWINDOW_H

#include <glibmm.h>

/* $Id: scrolledwindow.hg,v 1.23 2002/07/13 19:03:01 murrayc Exp $ */

/* scrolledwindow.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/bin.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkScrolledWindow GtkScrolledWindow;
typedef struct _GtkScrolledWindowClass GtkScrolledWindowClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class ScrolledWindow_Class; } // namespace Gtk
namespace Gtk
{

class Adjustment;
class HScrollbar;
class VScrollbar;

/** Adds scrollbars to its child widget.
 *
 * This container accepts a single child widget. It adds scrollbars to the child widget and optionally draws a beveled frame around the child widget.
 * The scrolled window can work in two ways:
 * 1) Some widgets have native scrolling support; these widgets handle certain Gtk::Adjustment signals. Widgets with native scroll support include Gtk::TreeView, Gtk::TextView, and Gtk::Layout.
 * 2) For widgets that lack native scrolling support, such as Gtk::Table, Gtk::Box, and so on, the widget will be placed inside a Gtk::Viewport.
 *
 * The position of the scrollbars is controlled by the scroll adjustments. See Gtk::Adjustment for the fields in an adjustment - for Gtk::Scrollbar, used by Gtk::ScrolledWindow,
 * the "value" field represents the position of the scrollbar, which must be between the "lower" field and "upper - page_size."
 * The "page_size" field represents the size of the visible scrollable area.
 * The "step_increment" and "page_increment" fields are used when the user asks to step down (using the small stepper arrows) or page down (using for example the PageDown key).
 *
 * If a Gtk::ScrolledWindow doesn't behave quite as you would like, or doesn't have exactly the right layout, it's very possible to set up your own scrolling with Gtk::Scrollbar and, for example, a Gtk::Table.
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class ScrolledWindow : public Bin
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef ScrolledWindow CppObjectType;
  typedef ScrolledWindow_Class CppClassType;
  typedef GtkScrolledWindow BaseObjectType;
  typedef GtkScrolledWindowClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~ScrolledWindow();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class ScrolledWindow_Class;
  static CppClassType scrolledwindow_class_;

  // noncopyable
  ScrolledWindow(const ScrolledWindow&);
  ScrolledWindow& operator=(const ScrolledWindow&);

protected:
  explicit ScrolledWindow(const Glib::ConstructParams& construct_params);
  explicit ScrolledWindow(GtkScrolledWindow* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  GtkScrolledWindow*       gobj()       { return reinterpret_cast<GtkScrolledWindow*>(gobject_); }
  const GtkScrolledWindow* gobj() const { return reinterpret_cast<GtkScrolledWindow*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_scroll_child(ScrollType scroll, bool horizontal);
  virtual void on_move_focus_out(DirectionType direction);


private:


public:
  ScrolledWindow();
  explicit ScrolledWindow(Adjustment& hadjustment, Adjustment& vadjustment);
  

  /** 
   * Sets the Gtk::Adjustment for the horizontal scrollbar.
   * 
   * @param hadjustment Horizontal scroll adjustment.
   */
  void set_hadjustment(Gtk::Adjustment* hadjustment = 0);
  
  /** 
   * Sets the Gtk::Adjustment for the vertical scrollbar.
   * 
   * @param hadjustment 
   */
  void set_vadjustment(Gtk::Adjustment* vadjustment = 0);
  
  /** 
   * Sets the Gtk::Adjustment for the horizontal scrollbar.
   * 
   * @param hadjustment Horizontal scroll adjustment.
   */
  void set_hadjustment(Gtk::Adjustment& hadjustment);
  
  /** 
   * Sets the Gtk::Adjustment for the vertical scrollbar.
   * 
   * @param hadjustment 
   */
  void set_vadjustment(Gtk::Adjustment& vadjustment);

  
  /** 
   * Returns the horizontal scrollbar's adjustment, used to connect the
   * horizontal scrollbar to the child widget's horizontal scroll
   * functionality.
   * 
   * @return The horizontal Gtk::Adjustment.
   */
  Gtk::Adjustment* get_hadjustment() const;
  
  /** 
   * Returns the vertical scrollbar's adjustment, used to connect the
   * vertical scrollbar to the child widget's vertical scroll
   * functionality.
   * 
   * @return The vertical Gtk::Adjustment.
   */
  Gtk::Adjustment* get_vadjustment() const;

  
  /** 
   * Sets the scrollbar policy for the horizontal and vertical scrollbars. 
   * The policy determines when the scrollbar should appear; it is a value
   * from the Gtk::PolicyType enumeration. If Gtk::POLICY_ALWAYS, the
   * scrollbar is always present; if Gtk::POLICY_NEVER, the scrollbar is
   * never present; if Gtk::POLICY_AUTOMATIC, the scrollbar is present only
   * if needed (that is, if the slider part of the bar would be smaller
   * than the trough - the display is larger than the page size).
   * 
   * @param hscrollbar_policy Policy for horizontal bar.
   * @param vscrollbar_policy Policy for vertical bar.
   */
  void set_policy(PolicyType hscrollbar_policy, PolicyType vscrollbar_policy);
  
  /** Retrieves the current policy values for the horizontal and vertical
   * scrollbars. See set_policy().
   * 
   * 
   * 
   * @param hscrollbar_policy Location to store the policy for the horizontal scrollbar, or <tt>0</tt>.
   * @param vscrollbar_policy Location to store the policy for the horizontal scrollbar, or <tt>0</tt>.
   */
  void get_policy(PolicyType& hscrollbar_policy, PolicyType& vscrollbar_policy) const;

  
  /** 
   * Determines the location of the child widget with respect to the
   * scrollbars. The default is Gtk::CORNER_TOP_LEFT, meaning the child is
   * in the top left, with the scrollbars underneath and to the right.
   * Other values in Gtk::CornerType are Gtk::CORNER_TOP_RIGHT,
   * Gtk::CORNER_BOTTOM_LEFT, and Gtk::CORNER_BOTTOM_RIGHT.
   * 
   * @param window_placement Position of the child window.
   */
  void set_placement(CornerType window_placement);
  
  /** Gets the placement of the scrollbars for the scrolled window. See 
   * set_placement().
   * 
   * 
   * 
   * 
   * @return The current placement value.
   */
  CornerType get_placement() const;

  
  /** Changes the type of shadow drawn around the contents of
   *  @a scrolled_window.
   * 
   * 
   * 
   * 
   * @param type Kind of shadow to draw around scrolled window contents.
   */
  void set_shadow_type(ShadowType type);
  
  /** Gets the shadow type of the scrolled window. See 
   * set_shadow_type().
   * 
   * 
   * 
   * 
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkScrolledWindow::move-focus-out ##### --&gt;
   * 
   * 
   * 
   * 
   * 
   * &lt;!-- ##### SIGNAL GtkScrolledWindow::scroll-child ##### --&gt;
   * 
   * 
   * 
   * 
   * 
   * &lt;!-- ##### ARG GtkScrolledWindow:hadjustment ##### --&gt;
   * 
   * Horizontal adjustment. See set_hadjustment(), get_hadjustment().
   * 
   * 
   * &lt;!-- ##### ARG GtkScrolledWindow:vadjustment ##### --&gt;
   * 
   * Vertical adjustment. See set_vadjustment(), get_vadjustment().
   * 
   * 
   * &lt;!-- ##### ARG GtkScrolledWindow:hscrollbar-policy ##### --&gt;
   * 
   * Horizontal scrollbar policy (show scrollbar always, never, or "when appropriate").
   * 
   * 
   * &lt;!-- ##### ARG GtkScrolledWindow:vscrollbar-policy ##### --&gt;
   * 
   * Vertical scrollbar policy (show scrollbar always, never, or "when appropriate").
   * 
   * 
   * &lt;!-- ##### ARG GtkScrolledWindow:window-placement ##### --&gt;
   * 
   * Position of child window with respect to scrollbars; top left, top
   * right, bottom left, bottom right.
   * 
   * 
   * &lt;!-- ##### ARG GtkScrolledWindow:shadow-type ##### --&gt;
   * 
   * Type of frame drawn around the child of the scrolled window.
   * 
   * @param scrolledwindow The object which received the signal.
   *  the object which received the signal.
   * @param arg1 
   * @param arg2 
   * @return The current shadow type.
   */
  ShadowType get_shadow_type() const;

  ///Puts the child inside a Gtk::Viewport if it doesn't have native scrolling capability.
  virtual void add(Gtk::Widget& widget);
  

  bool get_vscrollbar_visible() const;
  bool get_hscrollbar_visible() const;
  Gtk::HScrollbar* get_hscrollbar();
  const Gtk::HScrollbar* get_hscrollbar() const;
  Gtk::VScrollbar* get_vscrollbar();
  const Gtk::VScrollbar* get_vscrollbar() const;

  
  /**
   * @par Prototype:
   * <tt>void %scroll_child(ScrollType scroll, bool horizontal)</tt>
   */
  Glib::SignalProxy2<void,ScrollType,bool> signal_scroll_child();

  
  /**
   * @par Prototype:
   * <tt>void %move_focus_out(DirectionType direction)</tt>
   */
  Glib::SignalProxy1<void,DirectionType> signal_move_focus_out();


  Glib::PropertyProxy<Gtk::Adjustment*> property_hadjustment();

  Glib::PropertyProxy<Gtk::Adjustment*> property_vadjustment();

  Glib::PropertyProxy<PolicyType> property_hscrollbar_policy();

  Glib::PropertyProxy<PolicyType> property_vscrollbar_policy();

  Glib::PropertyProxy<CornerType> property_window_placement();

  Glib::PropertyProxy<ShadowType> property_shadow_type();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::ScrolledWindow */
  Gtk::ScrolledWindow* wrap(GtkScrolledWindow* object, bool take_copy = false);
}
#endif /* _GTKMM_SCROLLEDWINDOW_H */

