// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _PANGOMM_CONTEXT_H
#define _PANGOMM_CONTEXT_H

#include <glibmm.h>

/* $Id: context.hg,v 1.12 2002/05/20 02:07:23 daniel Exp $ */

/* context.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <glibmm/object.h>
#include <glibmm/arrayhandle.h>
//#include <pangomm/font.h>
#include <pangomm/fontdescription.h>
#include <pangomm/fontmetrics.h>
#include <pangomm/fontset.h>
#include <pangomm/fontmap.h>
#include <pango/pango-context.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _PangoContext PangoContext;
typedef struct _PangoContextClass PangoContextClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Pango
{ class Context_Class; } // namespace Pango
namespace Pango
{


/** @addtogroup pangommEnums Enums and Flags */

/**
 * @ingroup pangommEnums
 */
enum Direction
{
  DIRECTION_LTR,
  DIRECTION_RTL,
  DIRECTION_TTB_LTR,
  DIRECTION_TTB_RTL
};

} // namespace Pango


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Pango::Direction> : public Glib::Value_Enum<Pango::Direction>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Pango
{


class Context : public Glib::Object
{
   
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Context CppObjectType;
  typedef Context_Class CppClassType;
  typedef PangoContext BaseObjectType;
  typedef PangoContextClass BaseClassType;

private:
  friend class Context_Class;
  static CppClassType context_class_;

  // noncopyable
  Context(const Context&);
  Context& operator=(const Context&);

protected:
  explicit Context(const Glib::ConstructParams& construct_params);
  explicit Context(PangoContext* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Context();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  PangoContext*       gobj()       { return reinterpret_cast<PangoContext*>(gobject_); }
  const PangoContext* gobj() const { return reinterpret_cast<PangoContext*>(gobject_); }

  PangoContext* gobj_copy();

private:

    //PANGO_ENABLE_BACKEND
protected:

  Context();

public:
  
  static Glib::RefPtr<Context> create();


  Glib::ArrayHandle< Glib::RefPtr<FontFamily> > list_families();
  
  Glib::RefPtr<Font> load_font(const FontDescription& desc);
  
  Glib::RefPtr<Fontset> load_fontset(const FontDescription& desc, PangoLanguage* language);
  
  FontMetrics get_metrics(const FontDescription& desc, const PangoLanguage* language);
  
  void set_font_description(const FontDescription& desc);
  
  FontDescription get_font_description();
  
  PangoLanguage* get_language();
  
  void set_language(const PangoLanguage* language);
  
  void set_base_dir(Direction direction);
  
  Direction get_base_dir();

//  _WRAP_METHOD(GList *pango_itemize (PangoContext      *context,
//                      const char        *text,
//                      int                start_index,
//                      int                length,
//                      PangoAttrList     *attrs,
//                      PangoAttrIterator *cached_iter);


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} /* namespace Pango */


namespace Glib
{
  /** @relates Pango::Context */
  Glib::RefPtr<Pango::Context> wrap(PangoContext* object, bool take_copy = false);
}


#endif /* _PANGOMM_CONTEXT_H */

